/* hopsel.c */

#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#ifdef _AIX
#include <sys/select.h>
#endif
#include <stdio.h>
#include <errno.h>

void application();

main(argc, argv)
int argc;
char *argv[];
{
 int sock, length, rval, msgsock, *stat, *addrlen;
 struct sockaddr_in server, *peer;
 char buf[1024];

 sock = socket(AF_INET, SOCK_STREAM, 0);
 server.sin_family = AF_INET;
 server.sin_addr.s_addr = INADDR_ANY;
 server.sin_port = atol(argv[1]);
 
 bind(sock, &server, sizeof(server));
 listen(sock, 5);

 do{
    msgsock = accept(sock, peer, addrlen);
    switch(fork()){
	case  0: { application(msgsock, argv[2], argv[3]); break;}
	case -1: { perror("fork"); break;}
	default: { close(msgsock); wait(stat); }
        }
 } while (1);
}

void application(com_sock, target, tport)
char *target, *tport;
int com_sock;
{
 int sock, on, i;
 struct sockaddr_in server;
 struct hostent *hp, *gethostbyname();
 char mbuf[1024];

 fd_set readmask, writemask, treadmask, twritemask;
 struct timeval timeout;

 timeout.tv_sec=1;

 sock = socket(AF_INET, SOCK_STREAM, 0);

 server.sin_family = AF_INET;
 hp = gethostbyname(target);
 bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
 server.sin_port = htons(atoi(tport));

 connect(sock, &server, sizeof(server));

 FD_ZERO(&readmask);
 FD_ZERO(&writemask);
 FD_ZERO(&treadmask);
 FD_ZERO(&twritemask);

 FD_SET(sock, &readmask);
 FD_SET(sock, &writemask);

 FD_SET(com_sock, &readmask);
 FD_SET(com_sock, &writemask);

twritemask=writemask; treadmask=writemask;

do{
   writemask=twritemask; readmask=twritemask;
   select(FD_SETSIZE, &readmask, NULL, NULL, NULL);
   select(FD_SETSIZE, NULL, &writemask, NULL, NULL);

   if(FD_ISSET(sock, &readmask))
      if(recv(sock, mbuf, 1, 0) != -1) send(com_sock, mbuf, 1, 0);

   if(FD_ISSET(com_sock, &readmask))
      if(recv(com_sock, mbuf, 1, 0) != -1) send(sock, mbuf, 1, 0);

  }
while(1);
}
